// Class Code set12B
// Consult board notes bn12
/*   Arrays as parameters and arguments
     Arrays as return types
     One form of search - the filter 
*/
     
// These two variables are global.
char [ ] answers1 = { 'a', 'c', 'd', 'e', 'b', 'b', 'a', 'c', 'd', 'a' };
char [ ] answers2 = { 'c', 'c', 'e', 'b', 'a', 'b', 'd' };

void draw( )
{
  print( "Printing array answers1: \n  ");
  printArray( answers1 );
  
 print( "Printing array answers2: \n  ");
  printArray( answers2 );
 
  // This array is a local variable.
  char [ ] answersAll = concat( answers1, answers2 );  // concat is in the Processing API
    print( "Printing array answersAll: \n  ");
  printArray( answersAll );
  
  
  char [ ] answersOdd = buildAnswersOdd( answersAll );
    print( "Printing array answersOdd: \n  ");
  printArray( answersOdd );
  
  
  println( "The number of a answers in answers1 is " + countLetter( answers1, 'a' ) );
  println( "The number of b answers in answers2 is " + countLetter( answers2, 'b' ) );
  println( "The number of c answers in answersOdd is " + countLetter( answersOdd, 'c' ) );
  
  noLoop( );
}


//  This function performs a type of search called a filter.
//  The loop traverses the array and visits each element.
//  The visit consists of comparing the element's value to 
//        the value of the parameter, letterToCount.
//  If they are the same, a count variable is incremented.
//  When the loop is finished, the count variable has the 
//        number of times the letterToCount was in the array.
int countLetter( char [ ] answers, char letterToCount )
{
    int letterCount = 0;
    for( int i = 0 ; i < answers.length  ; i++ )
    {  //println( answers[i] +  "  " + letterToCount );
      if ( answers[i] == letterToCount )
      {
         letterCount++; 
      }
    }
    return letterCount;  
}

// This builds and returns a new array that has only the odd indexed elements of the
//   array the parameter references.
//       Travers the array but visit only the odd indexed elements.
//       Append them to the array of char, temp.
//       Return temp when the loop is finished.
char [ ] buildAnswersOdd( char [ ] answers )
{
    char [ ] temp = { };  // right now temp is an empty array of char
    for( int i = 1 ;i < answers.length  ;  i = i + 2 )  // note the init value and the update
    {
       {
         temp = append( temp, answers[i] );  // append is in the Processing API
       }
    }  
    return temp;  // temp now has only the odd indexed values in the original array
}


// Traverses and prints all elements of the array
// The argument is referencing the same array that the paramete references
void printArray( char [ ] answers)
{
    for( int i = 0 ; i < answers.length  ; i++ )
    {
      print( answers[i] + "  " );
    }
    println( );
}


